/*
Copyright (c) 2007, Trenton Schulz

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
    this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.

 3. The name of the author may not be used to endorse or promote products
    derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include <QtCore/QSocketNotifier>
#include <QtNetwork/QHostInfo>

#include <QrfeSleeper>

#include "../inc/QrfeBonjourRecord.h"
#include "../inc/QrfeBonjourServiceResolver.h"

QrfeBonjourServiceResolver::QrfeBonjourServiceResolver(QObject *parent)
    : QObject(parent), dnssref(0), bonjourSocket(0), bonjourPort(-1)
{
	m_resolveLock = false;
	m_resolveFinished = false;
}

QrfeBonjourServiceResolver::~QrfeBonjourServiceResolver()
{
    cleanupResolve();
}

bool QrfeBonjourServiceResolver::resolveBonjourRecord(const QrfeBonjourRecord &record, QHostInfo &hostInfo, int &port)
{
	int i = 0;
	while(m_resolveLock == true)
	{
		QrfeSleeper::MSleepAlive(5);
		if(i++ == 2000)
			return false;
	}

	m_resolveLock = true;
	m_resolveFinished = false;

	resolveBonjourRecord(record);

	i = 0;
	while(m_resolveFinished != true)
	{
		QrfeSleeper::MSleepAlive(5);
		if(i++ == 2000)
			break;
	}

	if(m_resolveFinished != true)
	{
		m_resolveLock = false;
		return false;
	}

	hostInfo = m_resolveInfo;
	port = m_resolvePort;

	return true;
}


void QrfeBonjourServiceResolver::cleanupResolve()
{
    if (dnssref) {
        DNSServiceRefDeallocate(dnssref);
        dnssref = 0;
        delete bonjourSocket;
        bonjourPort = -1;
    }
}

void QrfeBonjourServiceResolver::resolveBonjourRecord(const QrfeBonjourRecord &record)
{
    if (dnssref) {
        qWarning("resolve in process, aborting");
        return;
    }
    DNSServiceErrorType err = DNSServiceResolve(&dnssref, 0, 0,
                                                record.serviceName.toUtf8().constData(),
                                                record.registeredType.toUtf8().constData(),
                                                record.replyDomain.toUtf8().constData(),
                                                (DNSServiceResolveReply)bonjourResolveReply, this);
    if (err != kDNSServiceErr_NoError) {
        emit error(err);
    } else {
        int sockfd = DNSServiceRefSockFD(dnssref);
        if (sockfd == -1) {
            emit error(kDNSServiceErr_Invalid);
        } else {
            bonjourSocket = new QSocketNotifier(sockfd, QSocketNotifier::Read, this);
            connect(bonjourSocket, SIGNAL(activated(int)), this, SLOT(bonjourSocketReadyRead()));
        }
    }
}

void QrfeBonjourServiceResolver::bonjourSocketReadyRead()
{
    DNSServiceErrorType err = DNSServiceProcessResult(dnssref);
    if (err != kDNSServiceErr_NoError)
        emit error(err);
}


void QrfeBonjourServiceResolver::bonjourResolveReply(DNSServiceRef, DNSServiceFlags ,
                                    quint32 , DNSServiceErrorType errorCode,
                                    const char *, const char *hosttarget, quint16 port,
                                    quint16 , const char *, void *context)
{
    QrfeBonjourServiceResolver *serviceResolver = static_cast<QrfeBonjourServiceResolver *>(context);
    if (errorCode != kDNSServiceErr_NoError) {
        emit serviceResolver->error(errorCode);
        return;
    }
#if Q_BYTE_ORDER == Q_LITTLE_ENDIAN
        {
            port =  0 | ((port & 0x00ff) << 8) | ((port & 0xff00) >> 8);
        }
#endif
    serviceResolver->bonjourPort = port;
    QHostInfo::lookupHost(QString::fromUtf8(hosttarget),
                          serviceResolver, SLOT(finishConnect(const QHostInfo &)));
}

void QrfeBonjourServiceResolver::finishConnect(const QHostInfo &hostInfo)
{
	m_resolveFinished = true;
	m_resolveInfo = hostInfo;
	m_resolvePort = bonjourPort;
    emit bonjourRecordResolved(hostInfo, bonjourPort);
    QMetaObject::invokeMethod(this, "cleanupResolve", Qt::QueuedConnection);
}
